<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>KWidgetItemDelegate</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>KWidgetItemDelegate Class Reference</h1>
<code>from PyKDE4.kdeui import *</code>
<p>
Inherits: <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qabstractitemdelegate.html">QAbstractItemDelegate</a> &#x2192; <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a><br />


<h2>Detailed Description</h2>
<dl class="abstract" compact><dt><b>Abstract class:</b></dt>
<dd>This class can be used as a base class for new classes, but can not be instantiated directly.</dd></dl>
<p>This class allows to create item delegates embedding simple widgets to interact
with items. For instance you can add push buttons, line edits, etc. to your delegate
and use them to modify the state of your model.
</p>
<p>
<dl class="since" compact><dt><b>Since:</b></dt><dd> 4.1
</dd></dl>
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj176431340">__init__</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qabstractitemview.html">QAbstractItemView</a> itemView, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> parent=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[QEvent::Type]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj178729644">blockedEventTypes</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> widget)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[QWidge]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj177838220">createItemWidgets</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpersistentmodelindex.html">QPersistentModelIndex</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj176432716">focusedIndex</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qabstractitemview.html">QAbstractItemView</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj180128716">itemView</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj177839628">paintWidgets</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpainter.html">QPainter</a> painter, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstyleoptionviewitem.html">QStyleOptionViewItem</a> option, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpersistentmodelindex.html">QPersistentModelIndex</a> index)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj180252172">setBlockedEventTypes</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> widget, [QEvent::Type] types)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj177838284">updateItemWidgets</a> (self, [QWidge] widgets, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstyleoptionviewitem.html">QStyleOptionViewItem</a> option, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpersistentmodelindex.html">QPersistentModelIndex</a> index)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj176431340"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qabstractitemview.html">QAbstractItemView</a>&nbsp;</td>
<td class="paramname"><em>itemView</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>parent=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Creates a new ItemDelegate to be used with a given itemview.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>itemView</em>&nbsp;</td><td> the item view the new delegate will monitor

<tr><td></td><td valign="top"><em>parent</em>&nbsp;</td><td> the parent of this delegate
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj178729644"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[QEvent::Type] blockedEventTypes</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a>&nbsp;</td>
<td class="paramname"><em>widget</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Retrieves the list of blocked event types for the given widget.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>widget</em>&nbsp;</td><td> the specified widget.
</td></tr>
</table></dl>
<p> <dl class="return" compact><dt><b>Returns:</b></dt><dd> the list of blocked event types, can be empty if no events are blocked.
</dd></dl>
</p></div></div><a class="anchor" name="obj177838220"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[QWidge] createItemWidgets</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><dl compact><dt><b>Abstract method:</b></dt><dd>This method is abstract and can be overridden but not called directly.</dd></dl><p>Creates the list of widgets needed for an item.
</p>
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd> No initialization of the widgets is supposed to happen here.
The widgets will be initialized based on needs for a given item.
</dd></dl> </p>
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd> If you want to connect some widget signals to any slot, you should
do it here.
</dd></dl> </p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> the list of newly created widgets which will be used to interact with an item.
</dd></dl> <dl class="see" compact><dt><b>See also:</b></dt><dd> updateItemWidgets()
</dd></dl>
</p></div></div><a class="anchor" name="obj176432716"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpersistentmodelindex.html">QPersistentModelIndex</a> focusedIndex</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Retrieves the currently focused index. An invalid index if none is focused.
</p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> the current focused index, or QPersistentModelIndex() if none is focused.
</dd></dl>
</p></div></div><a class="anchor" name="obj180128716"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qabstractitemview.html">QAbstractItemView</a> itemView</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Retrieves the item view this delegate is monitoring.
</p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> the item view this delegate is monitoring
</dd></dl>
</p></div></div><a class="anchor" name="obj177839628"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> paintWidgets</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpainter.html">QPainter</a>&nbsp;</td>
<td class="paramname"><em>painter</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstyleoptionviewitem.html">QStyleOptionViewItem</a>&nbsp;</td>
<td class="paramname"><em>option</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpersistentmodelindex.html">QPersistentModelIndex</a>&nbsp;</td>
<td class="paramname"><em>index</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Paint the widgets of the item. This method is meant to be used in the paint()
method of your item delegate implementation.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>painter</em>&nbsp;</td><td> the painter the widgets will be painted on.

<tr><td></td><td valign="top"><em>option</em>&nbsp;</td><td> the current set of style options for the view.

<tr><td></td><td valign="top"><em>index</em>&nbsp;</td><td> the model index of the item currently painted.
</td></tr>
</table></dl>
<p> <dl class="warning" compact><dt><b>Warning:</b></dt><dd> since 4.2 this method is not longer needed to be called. All widgets will kept
updated without the need of calling paintWidgets() in your paint() event. For the
widgets of a certain index to be updated your model has to emit dataChanged() on the
indexes that want to be updated.
</dd></dl>
</p></div></div><a class="anchor" name="obj180252172"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setBlockedEventTypes</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a>&nbsp;</td>
<td class="paramname"><em>widget</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">[QEvent::Type]&nbsp;</td>
<td class="paramname"><em>types</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Sets the list of event <b>types</b> that a <b>widget</b> will block.
</p>
<p>
Blocked events are not passed to the view. This way you can prevent an item
from being selected when a button is clicked for instance.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>widget</em>&nbsp;</td><td> the widget which must block events

<tr><td></td><td valign="top"><em>types</em>&nbsp;</td><td> the list of event types the widget must block
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj177838284"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> updateItemWidgets</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">[QWidge]&nbsp;</td>
<td class="paramname"><em>widgets</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstyleoptionviewitem.html">QStyleOptionViewItem</a>&nbsp;</td>
<td class="paramname"><em>option</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qpersistentmodelindex.html">QPersistentModelIndex</a>&nbsp;</td>
<td class="paramname"><em>index</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><dl compact><dt><b>Abstract method:</b></dt><dd>This method is abstract and can be overridden but not called directly.</dd></dl><p>Updates a list of widgets for its use inside of the delegate (painting or
event handling).
</p>
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd> All the positioning and sizing should be done in item coordinates.
</dd></dl> </p>
<p>
<dl class="warning" compact><dt><b>Warning:</b></dt><dd> Do not make widget connections in here, since this method will
be called very regularly.
</dd></dl> </p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>widgets</em>&nbsp;</td><td> the widgets to update

<tr><td></td><td valign="top"><em>option</em>&nbsp;</td><td> the current set of style options for the view.

<tr><td></td><td valign="top"><em>index</em>&nbsp;</td><td> the model index of the item currently manipulated.
</td></tr>
</table></dl>
<p>
</p></div></div>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
